/* DeviceRow.c generated by valac 0.42.3, the Vala compiler
 * generated from DeviceRow.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2016 elementary LLC.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <pango/pango.h>


#define BLUETOOTH_TYPE_DEVICE_ROW (bluetooth_device_row_get_type ())
#define BLUETOOTH_DEVICE_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BLUETOOTH_TYPE_DEVICE_ROW, BluetoothDeviceRow))
#define BLUETOOTH_DEVICE_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BLUETOOTH_TYPE_DEVICE_ROW, BluetoothDeviceRowClass))
#define BLUETOOTH_IS_DEVICE_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BLUETOOTH_TYPE_DEVICE_ROW))
#define BLUETOOTH_IS_DEVICE_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BLUETOOTH_TYPE_DEVICE_ROW))
#define BLUETOOTH_DEVICE_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BLUETOOTH_TYPE_DEVICE_ROW, BluetoothDeviceRowClass))

typedef struct _BluetoothDeviceRow BluetoothDeviceRow;
typedef struct _BluetoothDeviceRowClass BluetoothDeviceRowClass;
typedef struct _BluetoothDeviceRowPrivate BluetoothDeviceRowPrivate;

#define BLUETOOTH_SERVICES_TYPE_DEVICE (bluetooth_services_device_get_type ())
#define BLUETOOTH_SERVICES_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BLUETOOTH_SERVICES_TYPE_DEVICE, BluetoothServicesDevice))
#define BLUETOOTH_SERVICES_IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BLUETOOTH_SERVICES_TYPE_DEVICE))
#define BLUETOOTH_SERVICES_DEVICE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), BLUETOOTH_SERVICES_TYPE_DEVICE, BluetoothServicesDeviceIface))

typedef struct _BluetoothServicesDevice BluetoothServicesDevice;
typedef struct _BluetoothServicesDeviceIface BluetoothServicesDeviceIface;

#define BLUETOOTH_SERVICES_TYPE_DEVICE_PROXY (bluetooth_services_device_proxy_get_type ())

#define BLUETOOTH_SERVICES_TYPE_ADAPTER (bluetooth_services_adapter_get_type ())
#define BLUETOOTH_SERVICES_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BLUETOOTH_SERVICES_TYPE_ADAPTER, BluetoothServicesAdapter))
#define BLUETOOTH_SERVICES_IS_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BLUETOOTH_SERVICES_TYPE_ADAPTER))
#define BLUETOOTH_SERVICES_ADAPTER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), BLUETOOTH_SERVICES_TYPE_ADAPTER, BluetoothServicesAdapterIface))

typedef struct _BluetoothServicesAdapter BluetoothServicesAdapter;
typedef struct _BluetoothServicesAdapterIface BluetoothServicesAdapterIface;

#define BLUETOOTH_SERVICES_TYPE_ADAPTER_PROXY (bluetooth_services_adapter_proxy_get_type ())
enum  {
	BLUETOOTH_DEVICE_ROW_0_PROPERTY,
	BLUETOOTH_DEVICE_ROW_DEVICE_PROPERTY,
	BLUETOOTH_DEVICE_ROW_ADAPTER_PROPERTY,
	BLUETOOTH_DEVICE_ROW_NUM_PROPERTIES
};
static GParamSpec* bluetooth_device_row_properties[BLUETOOTH_DEVICE_ROW_NUM_PROPERTIES];

#define BLUETOOTH_DEVICE_ROW_TYPE_STATUS (bluetooth_device_row_status_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _BluetoothDeviceRowButtonClickedData BluetoothDeviceRowButtonClickedData;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block2Data Block2Data;
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

struct _BluetoothDeviceRow {
	GtkListBoxRow parent_instance;
	BluetoothDeviceRowPrivate * priv;
};

struct _BluetoothDeviceRowClass {
	GtkListBoxRowClass parent_class;
};

struct _BluetoothServicesDeviceIface {
	GTypeInterface parent_iface;
	void (*cancel_pairing) (BluetoothServicesDevice* self, GError** error);
	void (*connect) (BluetoothServicesDevice* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*connect_finish) (BluetoothServicesDevice* self, GAsyncResult* _res_, GError** error);
	void (*connect_profile) (BluetoothServicesDevice* self, const gchar* UUID, GError** error);
	void (*disconnect) (BluetoothServicesDevice* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*disconnect_finish) (BluetoothServicesDevice* self, GAsyncResult* _res_, GError** error);
	void (*disconnect_profile) (BluetoothServicesDevice* self, const gchar* UUID, GError** error);
	void (*pair) (BluetoothServicesDevice* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*pair_finish) (BluetoothServicesDevice* self, GAsyncResult* _res_, GError** error);
	gchar** (*get_UUIDs) (BluetoothServicesDevice* self, int* result_length1);
	gboolean (*get_blocked) (BluetoothServicesDevice* self);
	void (*set_blocked) (BluetoothServicesDevice* self, gboolean value);
	gboolean (*get_connected) (BluetoothServicesDevice* self);
	gboolean (*get_legacy_pairing) (BluetoothServicesDevice* self);
	gboolean (*get_paired) (BluetoothServicesDevice* self);
	gboolean (*get_trusted) (BluetoothServicesDevice* self);
	void (*set_trusted) (BluetoothServicesDevice* self, gboolean value);
	gint16 (*get_RSSI) (BluetoothServicesDevice* self);
	char* (*get_adapter) (BluetoothServicesDevice* self);
	gchar* (*get_address) (BluetoothServicesDevice* self);
	gchar* (*get_alias) (BluetoothServicesDevice* self);
	void (*set_alias) (BluetoothServicesDevice* self, const gchar* value);
	gchar* (*get_icon) (BluetoothServicesDevice* self);
	gchar* (*get_modalias) (BluetoothServicesDevice* self);
	gchar* (*get_name) (BluetoothServicesDevice* self);
	guint16 (*get_appearance) (BluetoothServicesDevice* self);
	guint32 (*get_class) (BluetoothServicesDevice* self);
};

struct _BluetoothServicesAdapterIface {
	GTypeInterface parent_iface;
	void (*remove_device) (BluetoothServicesAdapter* self, const char* device, GError** error);
	void (*set_discovery_filter) (BluetoothServicesAdapter* self, GHashTable* properties, GError** error);
	void (*start_discovery) (BluetoothServicesAdapter* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*start_discovery_finish) (BluetoothServicesAdapter* self, GAsyncResult* _res_, GError** error);
	void (*stop_discovery) (BluetoothServicesAdapter* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*stop_discovery_finish) (BluetoothServicesAdapter* self, GAsyncResult* _res_, GError** error);
	gchar** (*get_UUIDs) (BluetoothServicesAdapter* self, int* result_length1);
	gboolean (*get_discoverable) (BluetoothServicesAdapter* self);
	void (*set_discoverable) (BluetoothServicesAdapter* self, gboolean value);
	gboolean (*get_discovering) (BluetoothServicesAdapter* self);
	gboolean (*get_pairable) (BluetoothServicesAdapter* self);
	void (*set_pairable) (BluetoothServicesAdapter* self, gboolean value);
	gboolean (*get_powered) (BluetoothServicesAdapter* self);
	void (*set_powered) (BluetoothServicesAdapter* self, gboolean value);
	gchar* (*get_address) (BluetoothServicesAdapter* self);
	gchar* (*get_alias) (BluetoothServicesAdapter* self);
	void (*set_alias) (BluetoothServicesAdapter* self, const gchar* value);
	gchar* (*get_modalias) (BluetoothServicesAdapter* self);
	gchar* (*get_name) (BluetoothServicesAdapter* self);
	guint (*get_class) (BluetoothServicesAdapter* self);
	guint (*get_discoverable_timeout) (BluetoothServicesAdapter* self);
	guint (*get_pairable_timeout) (BluetoothServicesAdapter* self);
};

struct _BluetoothDeviceRowPrivate {
	BluetoothServicesDevice* _device;
	BluetoothServicesAdapter* _adapter;
	GtkButton* connect_button;
	GtkImage* state;
	GtkLabel* state_label;
	GtkLinkButton* settings_button;
};

typedef enum  {
	BLUETOOTH_DEVICE_ROW_STATUS_UNPAIRED,
	BLUETOOTH_DEVICE_ROW_STATUS_PAIRING,
	BLUETOOTH_DEVICE_ROW_STATUS_CONNECTED,
	BLUETOOTH_DEVICE_ROW_STATUS_CONNECTING,
	BLUETOOTH_DEVICE_ROW_STATUS_DISCONNECTING,
	BLUETOOTH_DEVICE_ROW_STATUS_NOT_CONNECTED,
	BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT
} BluetoothDeviceRowStatus;

struct _BluetoothDeviceRowButtonClickedData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	BluetoothDeviceRow* self;
	BluetoothServicesDevice* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	BluetoothServicesDevice* _tmp3_;
	BluetoothServicesDevice* _tmp4_;
	GError* e;
	GError* _tmp5_;
	const gchar* _tmp6_;
	BluetoothServicesDevice* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	BluetoothServicesDevice* _tmp10_;
	GError* _vala1_e;
	GError* _tmp11_;
	const gchar* _tmp12_;
	BluetoothServicesDevice* _tmp13_;
	GError* _vala2_e;
	GtkImage* _tmp14_;
	GError* _tmp15_;
	const gchar* _tmp16_;
	GError * _inner_error_;
};

struct _Block2Data {
	int _ref_count_;
	BluetoothDeviceRow* self;
	GtkImage* image;
	GtkLabel* label;
};


static gint BluetoothDeviceRow_private_offset;
static gpointer bluetooth_device_row_parent_class = NULL;
static GtkSizeGroup* bluetooth_device_row_size_group;
static GtkSizeGroup* bluetooth_device_row_size_group = NULL;

GType bluetooth_device_row_get_type (void) G_GNUC_CONST;
GType bluetooth_services_device_proxy_get_type (void) G_GNUC_CONST;
guint bluetooth_services_device_register_object (void* object,
                                                 GDBusConnection* connection,
                                                 const gchar* path,
                                                 GError** error);
GType bluetooth_services_device_get_type (void) G_GNUC_CONST;
GType bluetooth_services_adapter_proxy_get_type (void) G_GNUC_CONST;
guint bluetooth_services_adapter_register_object (void* object,
                                                  GDBusConnection* connection,
                                                  const gchar* path,
                                                  GError** error);
GType bluetooth_services_adapter_get_type (void) G_GNUC_CONST;
static GType bluetooth_device_row_status_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static gchar* bluetooth_device_row_status_to_string (BluetoothDeviceRowStatus self);
BluetoothDeviceRow* bluetooth_device_row_new (BluetoothServicesDevice* device,
                                              BluetoothServicesAdapter* adapter);
BluetoothDeviceRow* bluetooth_device_row_construct (GType object_type,
                                                    BluetoothServicesDevice* device,
                                                    BluetoothServicesAdapter* adapter);
static void bluetooth_device_row_button_clicked_data_free (gpointer _data);
static void bluetooth_device_row_button_clicked_async_ready_wrapper (GObject *source_object,
                                                              GAsyncResult *res,
                                                              void *user_data);
static void bluetooth_device_row_button_clicked (BluetoothDeviceRow* self,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_);
static void bluetooth_device_row_button_clicked_finish (BluetoothDeviceRow* self,
                                                 GAsyncResult* _res_);
static gboolean bluetooth_device_row_button_clicked_co (BluetoothDeviceRowButtonClickedData* _data_);
BluetoothServicesDevice* bluetooth_device_row_get_device (BluetoothDeviceRow* self);
gboolean bluetooth_services_device_get_paired (BluetoothServicesDevice* self);
static void bluetooth_device_row_set_status (BluetoothDeviceRow* self,
                                      BluetoothDeviceRowStatus status);
void bluetooth_services_device_pair (BluetoothServicesDevice* self,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_);
void bluetooth_services_device_pair_finish (BluetoothServicesDevice* self,
                                            GAsyncResult* _res_,
                                            GError** error);
static void bluetooth_device_row_button_clicked_ready (GObject* source_object,
                                                GAsyncResult* _res_,
                                                gpointer _user_data_);
void bluetooth_services_device_set_trusted (BluetoothServicesDevice* self,
                                            gboolean value);
gboolean bluetooth_services_device_get_connected (BluetoothServicesDevice* self);
void bluetooth_services_device_connect (BluetoothServicesDevice* self,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_);
void bluetooth_services_device_connect_finish (BluetoothServicesDevice* self,
                                               GAsyncResult* _res_,
                                               GError** error);
void bluetooth_services_device_disconnect (BluetoothServicesDevice* self,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
void bluetooth_services_device_disconnect_finish (BluetoothServicesDevice* self,
                                                  GAsyncResult* _res_,
                                                  GError** error);
static void bluetooth_device_row_compute_status (BluetoothDeviceRow* self);
static void bluetooth_device_row_set_device (BluetoothDeviceRow* self,
                                      BluetoothServicesDevice* value);
BluetoothServicesAdapter* bluetooth_device_row_get_adapter (BluetoothDeviceRow* self);
static void bluetooth_device_row_set_adapter (BluetoothDeviceRow* self,
                                       BluetoothServicesAdapter* value);
static GObject * bluetooth_device_row_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
gchar* bluetooth_services_device_get_icon (BluetoothServicesDevice* self);
gchar* bluetooth_services_device_get_address (BluetoothServicesDevice* self);
gchar* bluetooth_services_device_get_name (BluetoothServicesDevice* self);
gboolean bluetooth_services_adapter_get_powered (BluetoothServicesAdapter* self);
static void _bluetooth_device_row___lambda8_ (BluetoothDeviceRow* self,
                                       GVariant* changed,
                                       gchar** invalid,
                                       int invalid_length1);
static void __bluetooth_device_row___lambda8__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                                          GVariant* changed_properties,
                                                                          gchar** invalidated_properties,
                                                                          gpointer self);
static void _bluetooth_device_row___lambda9_ (Block2Data* _data2_,
                                       GVariant* changed,
                                       gchar** invalid,
                                       int invalid_length1);
static void __bluetooth_device_row___lambda9__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                                          GVariant* changed_properties,
                                                                          gchar** invalidated_properties,
                                                                          gpointer self);
static void _bluetooth_device_row___lambda10_ (BluetoothDeviceRow* self);
static void __bluetooth_device_row___lambda10__gtk_button_clicked (GtkButton* _sender,
                                                            gpointer self);
static void bluetooth_device_row_finalize (GObject * obj);
static void _vala_bluetooth_device_row_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_bluetooth_device_row_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);
static gint _vala_array_length (gpointer array);


static inline gpointer
bluetooth_device_row_get_instance_private (BluetoothDeviceRow* self)
{
	return G_STRUCT_MEMBER_P (self, BluetoothDeviceRow_private_offset);
}


static gchar*
bluetooth_device_row_status_to_string (BluetoothDeviceRowStatus self)
{
	gchar* result = NULL;
#line 36 "../src/DeviceRow.vala"
	switch (self) {
#line 36 "../src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_STATUS_UNPAIRED:
#line 333 "DeviceRow.c"
		{
			gchar* _tmp0_;
#line 38 "../src/DeviceRow.vala"
			_tmp0_ = g_strdup (_ ("Available"));
#line 38 "../src/DeviceRow.vala"
			result = _tmp0_;
#line 38 "../src/DeviceRow.vala"
			return result;
#line 342 "DeviceRow.c"
		}
#line 36 "../src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_STATUS_PAIRING:
#line 346 "DeviceRow.c"
		{
			gchar* _tmp1_;
#line 40 "../src/DeviceRow.vala"
			_tmp1_ = g_strdup (_ ("Pairing…"));
#line 40 "../src/DeviceRow.vala"
			result = _tmp1_;
#line 40 "../src/DeviceRow.vala"
			return result;
#line 355 "DeviceRow.c"
		}
#line 36 "../src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_STATUS_CONNECTED:
#line 359 "DeviceRow.c"
		{
			gchar* _tmp2_;
#line 42 "../src/DeviceRow.vala"
			_tmp2_ = g_strdup (_ ("Connected"));
#line 42 "../src/DeviceRow.vala"
			result = _tmp2_;
#line 42 "../src/DeviceRow.vala"
			return result;
#line 368 "DeviceRow.c"
		}
#line 36 "../src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_STATUS_CONNECTING:
#line 372 "DeviceRow.c"
		{
			gchar* _tmp3_;
#line 44 "../src/DeviceRow.vala"
			_tmp3_ = g_strdup (_ ("Connecting…"));
#line 44 "../src/DeviceRow.vala"
			result = _tmp3_;
#line 44 "../src/DeviceRow.vala"
			return result;
#line 381 "DeviceRow.c"
		}
#line 36 "../src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_STATUS_DISCONNECTING:
#line 385 "DeviceRow.c"
		{
			gchar* _tmp4_;
#line 46 "../src/DeviceRow.vala"
			_tmp4_ = g_strdup (_ ("Disconnecting…"));
#line 46 "../src/DeviceRow.vala"
			result = _tmp4_;
#line 46 "../src/DeviceRow.vala"
			return result;
#line 394 "DeviceRow.c"
		}
#line 36 "../src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT:
#line 398 "DeviceRow.c"
		{
			gchar* _tmp5_;
#line 48 "../src/DeviceRow.vala"
			_tmp5_ = g_strdup (_ ("Unable to Connnect"));
#line 48 "../src/DeviceRow.vala"
			result = _tmp5_;
#line 48 "../src/DeviceRow.vala"
			return result;
#line 407 "DeviceRow.c"
		}
		default:
		{
			gchar* _tmp6_;
#line 50 "../src/DeviceRow.vala"
			_tmp6_ = g_strdup (_ ("Not Connected"));
#line 50 "../src/DeviceRow.vala"
			result = _tmp6_;
#line 50 "../src/DeviceRow.vala"
			return result;
#line 418 "DeviceRow.c"
		}
	}
}


static GType
bluetooth_device_row_status_get_type (void)
{
	static volatile gsize bluetooth_device_row_status_type_id__volatile = 0;
	if (g_once_init_enter (&bluetooth_device_row_status_type_id__volatile)) {
		static const GEnumValue values[] = {{BLUETOOTH_DEVICE_ROW_STATUS_UNPAIRED, "BLUETOOTH_DEVICE_ROW_STATUS_UNPAIRED", "unpaired"}, {BLUETOOTH_DEVICE_ROW_STATUS_PAIRING, "BLUETOOTH_DEVICE_ROW_STATUS_PAIRING", "pairing"}, {BLUETOOTH_DEVICE_ROW_STATUS_CONNECTED, "BLUETOOTH_DEVICE_ROW_STATUS_CONNECTED", "connected"}, {BLUETOOTH_DEVICE_ROW_STATUS_CONNECTING, "BLUETOOTH_DEVICE_ROW_STATUS_CONNECTING", "connecting"}, {BLUETOOTH_DEVICE_ROW_STATUS_DISCONNECTING, "BLUETOOTH_DEVICE_ROW_STATUS_DISCONNECTING", "disconnecting"}, {BLUETOOTH_DEVICE_ROW_STATUS_NOT_CONNECTED, "BLUETOOTH_DEVICE_ROW_STATUS_NOT_CONNECTED", "not-connected"}, {BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT, "BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT", "unable-to-connect"}, {0, NULL, NULL}};
		GType bluetooth_device_row_status_type_id;
		bluetooth_device_row_status_type_id = g_enum_register_static ("BluetoothDeviceRowStatus", values);
		g_once_init_leave (&bluetooth_device_row_status_type_id__volatile, bluetooth_device_row_status_type_id);
	}
	return bluetooth_device_row_status_type_id__volatile;
}


BluetoothDeviceRow*
bluetooth_device_row_construct (GType object_type,
                                BluetoothServicesDevice* device,
                                BluetoothServicesAdapter* adapter)
{
	BluetoothDeviceRow * self = NULL;
#line 60 "../src/DeviceRow.vala"
	g_return_val_if_fail (device != NULL, NULL);
#line 60 "../src/DeviceRow.vala"
	g_return_val_if_fail (adapter != NULL, NULL);
#line 61 "../src/DeviceRow.vala"
	self = (BluetoothDeviceRow*) g_object_new (object_type, "device", device, "adapter", adapter, NULL);
#line 60 "../src/DeviceRow.vala"
	return self;
#line 452 "DeviceRow.c"
}


BluetoothDeviceRow*
bluetooth_device_row_new (BluetoothServicesDevice* device,
                          BluetoothServicesAdapter* adapter)
{
#line 60 "../src/DeviceRow.vala"
	return bluetooth_device_row_construct (BLUETOOTH_TYPE_DEVICE_ROW, device, adapter);
#line 462 "DeviceRow.c"
}


static void
bluetooth_device_row_button_clicked_data_free (gpointer _data)
{
	BluetoothDeviceRowButtonClickedData* _data_;
	_data_ = _data;
#line 21 "../src/DeviceRow.vala"
	_g_object_unref0 (_data_->self);
#line 21 "../src/DeviceRow.vala"
	g_slice_free (BluetoothDeviceRowButtonClickedData, _data_);
#line 475 "DeviceRow.c"
}


static void
bluetooth_device_row_button_clicked_async_ready_wrapper (GObject *source_object,
                                                         GAsyncResult *res,
                                                         void *user_data)
{
	BluetoothDeviceRowButtonClickedData* _task_data_;
#line 21 "../src/DeviceRow.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 21 "../src/DeviceRow.vala"
	if (_task_data_->_callback_ != NULL) {
#line 21 "../src/DeviceRow.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 491 "DeviceRow.c"
	}
#line 21 "../src/DeviceRow.vala"
	_task_data_->_task_complete_ = TRUE;
#line 495 "DeviceRow.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 21 "../src/DeviceRow.vala"
	return self ? g_object_ref (self) : NULL;
#line 504 "DeviceRow.c"
}


static void
bluetooth_device_row_button_clicked (BluetoothDeviceRow* self,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_)
{
	BluetoothDeviceRowButtonClickedData* _data_;
	BluetoothDeviceRow* _tmp0_;
#line 21 "../src/DeviceRow.vala"
	_data_ = g_slice_new0 (BluetoothDeviceRowButtonClickedData);
#line 21 "../src/DeviceRow.vala"
	_data_->_callback_ = _callback_;
#line 21 "../src/DeviceRow.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, bluetooth_device_row_button_clicked_async_ready_wrapper, _user_data_);
#line 21 "../src/DeviceRow.vala"
	if (_callback_ == NULL) {
#line 21 "../src/DeviceRow.vala"
		_data_->_task_complete_ = TRUE;
#line 525 "DeviceRow.c"
	}
#line 21 "../src/DeviceRow.vala"
	g_task_set_task_data (_data_->_async_result, _data_, bluetooth_device_row_button_clicked_data_free);
#line 21 "../src/DeviceRow.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 21 "../src/DeviceRow.vala"
	_data_->self = _tmp0_;
#line 21 "../src/DeviceRow.vala"
	bluetooth_device_row_button_clicked_co (_data_);
#line 535 "DeviceRow.c"
}


static void
bluetooth_device_row_button_clicked_finish (BluetoothDeviceRow* self,
                                            GAsyncResult* _res_)
{
	BluetoothDeviceRowButtonClickedData* _data_;
#line 21 "../src/DeviceRow.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 546 "DeviceRow.c"
}


static void
bluetooth_device_row_button_clicked_ready (GObject* source_object,
                                           GAsyncResult* _res_,
                                           gpointer _user_data_)
{
	BluetoothDeviceRowButtonClickedData* _data_;
#line 179 "../src/DeviceRow.vala"
	_data_ = _user_data_;
#line 179 "../src/DeviceRow.vala"
	_data_->_source_object_ = source_object;
#line 179 "../src/DeviceRow.vala"
	_data_->_res_ = _res_;
#line 179 "../src/DeviceRow.vala"
	_data_->_task_complete_ = TRUE;
#line 179 "../src/DeviceRow.vala"
	bluetooth_device_row_button_clicked_co (_data_);
#line 566 "DeviceRow.c"
}


static gboolean
bluetooth_device_row_button_clicked_co (BluetoothDeviceRowButtonClickedData* _data_)
{
#line 175 "../src/DeviceRow.vala"
	switch (_data_->_state_) {
#line 175 "../src/DeviceRow.vala"
		case 0:
#line 577 "DeviceRow.c"
		goto _state_0;
#line 175 "../src/DeviceRow.vala"
		case 1:
#line 581 "DeviceRow.c"
		goto _state_1;
#line 175 "../src/DeviceRow.vala"
		case 2:
#line 585 "DeviceRow.c"
		goto _state_2;
#line 175 "../src/DeviceRow.vala"
		case 3:
#line 589 "DeviceRow.c"
		goto _state_3;
		default:
#line 175 "../src/DeviceRow.vala"
		g_assert_not_reached ();
#line 594 "DeviceRow.c"
	}
	_state_0:
#line 176 "../src/DeviceRow.vala"
	_data_->_tmp0_ = _data_->self->priv->_device;
#line 176 "../src/DeviceRow.vala"
	_data_->_tmp1_ = bluetooth_services_device_get_paired (_data_->_tmp0_);
#line 176 "../src/DeviceRow.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 176 "../src/DeviceRow.vala"
	if (!_data_->_tmp2_) {
#line 177 "../src/DeviceRow.vala"
		bluetooth_device_row_set_status (_data_->self, BLUETOOTH_DEVICE_ROW_STATUS_PAIRING);
#line 607 "DeviceRow.c"
		{
#line 179 "../src/DeviceRow.vala"
			_data_->_tmp3_ = _data_->self->priv->_device;
#line 179 "../src/DeviceRow.vala"
			_data_->_state_ = 1;
#line 179 "../src/DeviceRow.vala"
			bluetooth_services_device_pair (_data_->_tmp3_, bluetooth_device_row_button_clicked_ready, _data_);
#line 179 "../src/DeviceRow.vala"
			return FALSE;
#line 617 "DeviceRow.c"
			_state_1:
#line 179 "../src/DeviceRow.vala"
			bluetooth_services_device_pair_finish (_data_->_tmp3_, _data_->_res_, &_data_->_inner_error_);
#line 179 "../src/DeviceRow.vala"
			if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 623 "DeviceRow.c"
				goto __catch1_g_error;
			}
#line 180 "../src/DeviceRow.vala"
			_data_->_tmp4_ = _data_->self->priv->_device;
#line 180 "../src/DeviceRow.vala"
			bluetooth_services_device_set_trusted (_data_->_tmp4_, TRUE);
#line 630 "DeviceRow.c"
		}
		goto __finally1;
		__catch1_g_error:
		{
#line 178 "../src/DeviceRow.vala"
			_data_->e = _data_->_inner_error_;
#line 178 "../src/DeviceRow.vala"
			_data_->_inner_error_ = NULL;
#line 182 "../src/DeviceRow.vala"
			bluetooth_device_row_set_status (_data_->self, BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT);
#line 183 "../src/DeviceRow.vala"
			_data_->_tmp5_ = _data_->e;
#line 183 "../src/DeviceRow.vala"
			_data_->_tmp6_ = _data_->_tmp5_->message;
#line 183 "../src/DeviceRow.vala"
			g_critical ("DeviceRow.vala:183: %s", _data_->_tmp6_);
#line 178 "../src/DeviceRow.vala"
			_g_error_free0 (_data_->e);
#line 649 "DeviceRow.c"
		}
		__finally1:
#line 178 "../src/DeviceRow.vala"
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 178 "../src/DeviceRow.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 178 "../src/DeviceRow.vala"
			g_clear_error (&_data_->_inner_error_);
#line 178 "../src/DeviceRow.vala"
			g_object_unref (_data_->_async_result);
#line 178 "../src/DeviceRow.vala"
			return FALSE;
#line 662 "DeviceRow.c"
		}
	} else {
#line 185 "../src/DeviceRow.vala"
		_data_->_tmp7_ = _data_->self->priv->_device;
#line 185 "../src/DeviceRow.vala"
		_data_->_tmp8_ = bluetooth_services_device_get_connected (_data_->_tmp7_);
#line 185 "../src/DeviceRow.vala"
		_data_->_tmp9_ = _data_->_tmp8_;
#line 185 "../src/DeviceRow.vala"
		if (!_data_->_tmp9_) {
#line 186 "../src/DeviceRow.vala"
			bluetooth_device_row_set_status (_data_->self, BLUETOOTH_DEVICE_ROW_STATUS_CONNECTING);
#line 675 "DeviceRow.c"
			{
#line 188 "../src/DeviceRow.vala"
				_data_->_tmp10_ = _data_->self->priv->_device;
#line 188 "../src/DeviceRow.vala"
				_data_->_state_ = 2;
#line 188 "../src/DeviceRow.vala"
				bluetooth_services_device_connect (_data_->_tmp10_, bluetooth_device_row_button_clicked_ready, _data_);
#line 188 "../src/DeviceRow.vala"
				return FALSE;
#line 685 "DeviceRow.c"
				_state_2:
#line 188 "../src/DeviceRow.vala"
				bluetooth_services_device_connect_finish (_data_->_tmp10_, _data_->_res_, &_data_->_inner_error_);
#line 188 "../src/DeviceRow.vala"
				if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 691 "DeviceRow.c"
					goto __catch2_g_error;
				}
			}
			goto __finally2;
			__catch2_g_error:
			{
#line 187 "../src/DeviceRow.vala"
				_data_->_vala1_e = _data_->_inner_error_;
#line 187 "../src/DeviceRow.vala"
				_data_->_inner_error_ = NULL;
#line 190 "../src/DeviceRow.vala"
				bluetooth_device_row_set_status (_data_->self, BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT);
#line 191 "../src/DeviceRow.vala"
				_data_->_tmp11_ = _data_->_vala1_e;
#line 191 "../src/DeviceRow.vala"
				_data_->_tmp12_ = _data_->_tmp11_->message;
#line 191 "../src/DeviceRow.vala"
				g_critical ("DeviceRow.vala:191: %s", _data_->_tmp12_);
#line 187 "../src/DeviceRow.vala"
				_g_error_free0 (_data_->_vala1_e);
#line 712 "DeviceRow.c"
			}
			__finally2:
#line 187 "../src/DeviceRow.vala"
			if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 187 "../src/DeviceRow.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 187 "../src/DeviceRow.vala"
				g_clear_error (&_data_->_inner_error_);
#line 187 "../src/DeviceRow.vala"
				g_object_unref (_data_->_async_result);
#line 187 "../src/DeviceRow.vala"
				return FALSE;
#line 725 "DeviceRow.c"
			}
		} else {
#line 194 "../src/DeviceRow.vala"
			bluetooth_device_row_set_status (_data_->self, BLUETOOTH_DEVICE_ROW_STATUS_DISCONNECTING);
#line 730 "DeviceRow.c"
			{
#line 196 "../src/DeviceRow.vala"
				_data_->_tmp13_ = _data_->self->priv->_device;
#line 196 "../src/DeviceRow.vala"
				_data_->_state_ = 3;
#line 196 "../src/DeviceRow.vala"
				bluetooth_services_device_disconnect (_data_->_tmp13_, bluetooth_device_row_button_clicked_ready, _data_);
#line 196 "../src/DeviceRow.vala"
				return FALSE;
#line 740 "DeviceRow.c"
				_state_3:
#line 196 "../src/DeviceRow.vala"
				bluetooth_services_device_disconnect_finish (_data_->_tmp13_, _data_->_res_, &_data_->_inner_error_);
#line 196 "../src/DeviceRow.vala"
				if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 746 "DeviceRow.c"
					goto __catch3_g_error;
				}
			}
			goto __finally3;
			__catch3_g_error:
			{
#line 195 "../src/DeviceRow.vala"
				_data_->_vala2_e = _data_->_inner_error_;
#line 195 "../src/DeviceRow.vala"
				_data_->_inner_error_ = NULL;
#line 198 "../src/DeviceRow.vala"
				_data_->_tmp14_ = _data_->self->priv->state;
#line 198 "../src/DeviceRow.vala"
				g_object_set (_data_->_tmp14_, "icon-name", "user-busy", NULL);
#line 199 "../src/DeviceRow.vala"
				_data_->_tmp15_ = _data_->_vala2_e;
#line 199 "../src/DeviceRow.vala"
				_data_->_tmp16_ = _data_->_tmp15_->message;
#line 199 "../src/DeviceRow.vala"
				g_critical ("DeviceRow.vala:199: %s", _data_->_tmp16_);
#line 195 "../src/DeviceRow.vala"
				_g_error_free0 (_data_->_vala2_e);
#line 769 "DeviceRow.c"
			}
			__finally3:
#line 195 "../src/DeviceRow.vala"
			if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 195 "../src/DeviceRow.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 195 "../src/DeviceRow.vala"
				g_clear_error (&_data_->_inner_error_);
#line 195 "../src/DeviceRow.vala"
				g_object_unref (_data_->_async_result);
#line 195 "../src/DeviceRow.vala"
				return FALSE;
#line 782 "DeviceRow.c"
			}
		}
	}
#line 175 "../src/DeviceRow.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 175 "../src/DeviceRow.vala"
	if (_data_->_state_ != 0) {
#line 175 "../src/DeviceRow.vala"
		while (_data_->_task_complete_ != TRUE) {
#line 175 "../src/DeviceRow.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 794 "DeviceRow.c"
		}
	}
#line 175 "../src/DeviceRow.vala"
	g_object_unref (_data_->_async_result);
#line 175 "../src/DeviceRow.vala"
	return FALSE;
#line 801 "DeviceRow.c"
}


static void
bluetooth_device_row_compute_status (BluetoothDeviceRow* self)
{
	BluetoothServicesDevice* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 204 "../src/DeviceRow.vala"
	g_return_if_fail (self != NULL);
#line 205 "../src/DeviceRow.vala"
	_tmp0_ = self->priv->_device;
#line 205 "../src/DeviceRow.vala"
	_tmp1_ = bluetooth_services_device_get_paired (_tmp0_);
#line 205 "../src/DeviceRow.vala"
	_tmp2_ = _tmp1_;
#line 205 "../src/DeviceRow.vala"
	if (!_tmp2_) {
#line 206 "../src/DeviceRow.vala"
		bluetooth_device_row_set_status (self, BLUETOOTH_DEVICE_ROW_STATUS_UNPAIRED);
#line 823 "DeviceRow.c"
	} else {
		BluetoothServicesDevice* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 207 "../src/DeviceRow.vala"
		_tmp3_ = self->priv->_device;
#line 207 "../src/DeviceRow.vala"
		_tmp4_ = bluetooth_services_device_get_connected (_tmp3_);
#line 207 "../src/DeviceRow.vala"
		_tmp5_ = _tmp4_;
#line 207 "../src/DeviceRow.vala"
		if (_tmp5_) {
#line 208 "../src/DeviceRow.vala"
			bluetooth_device_row_set_status (self, BLUETOOTH_DEVICE_ROW_STATUS_CONNECTED);
#line 838 "DeviceRow.c"
		} else {
#line 210 "../src/DeviceRow.vala"
			bluetooth_device_row_set_status (self, BLUETOOTH_DEVICE_ROW_STATUS_NOT_CONNECTED);
#line 842 "DeviceRow.c"
		}
	}
}


static void
bluetooth_device_row_set_status (BluetoothDeviceRow* self,
                                 BluetoothDeviceRowStatus status)
{
	GtkLabel* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 214 "../src/DeviceRow.vala"
	g_return_if_fail (self != NULL);
#line 215 "../src/DeviceRow.vala"
	_tmp0_ = self->priv->state_label;
#line 215 "../src/DeviceRow.vala"
	_tmp1_ = bluetooth_device_row_status_to_string (status);
#line 215 "../src/DeviceRow.vala"
	_tmp2_ = _tmp1_;
#line 215 "../src/DeviceRow.vala"
	_tmp3_ = g_markup_printf_escaped ("<span font_size='small'>%s</span>", _tmp2_);
#line 215 "../src/DeviceRow.vala"
	_tmp4_ = _tmp3_;
#line 215 "../src/DeviceRow.vala"
	gtk_label_set_label (_tmp0_, _tmp4_);
#line 215 "../src/DeviceRow.vala"
	_g_free0 (_tmp4_);
#line 215 "../src/DeviceRow.vala"
	_g_free0 (_tmp2_);
#line 217 "../src/DeviceRow.vala"
	switch (status) {
#line 217 "../src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_STATUS_UNPAIRED:
#line 879 "DeviceRow.c"
		{
			GtkButton* _tmp5_;
			GtkButton* _tmp6_;
			GtkImage* _tmp7_;
			GtkLinkButton* _tmp8_;
#line 219 "../src/DeviceRow.vala"
			_tmp5_ = self->priv->connect_button;
#line 219 "../src/DeviceRow.vala"
			gtk_button_set_label (_tmp5_, _ ("Pair"));
#line 220 "../src/DeviceRow.vala"
			_tmp6_ = self->priv->connect_button;
#line 220 "../src/DeviceRow.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, TRUE);
#line 221 "../src/DeviceRow.vala"
			_tmp7_ = self->priv->state;
#line 221 "../src/DeviceRow.vala"
			g_object_set (_tmp7_, "icon-name", "user-offline", NULL);
#line 222 "../src/DeviceRow.vala"
			_tmp8_ = self->priv->settings_button;
#line 222 "../src/DeviceRow.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp8_, FALSE);
#line 223 "../src/DeviceRow.vala"
			break;
#line 903 "DeviceRow.c"
		}
#line 217 "../src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_STATUS_PAIRING:
#line 907 "DeviceRow.c"
		{
			GtkButton* _tmp9_;
			GtkImage* _tmp10_;
			GtkLinkButton* _tmp11_;
#line 225 "../src/DeviceRow.vala"
			_tmp9_ = self->priv->connect_button;
#line 225 "../src/DeviceRow.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp9_, FALSE);
#line 226 "../src/DeviceRow.vala"
			_tmp10_ = self->priv->state;
#line 226 "../src/DeviceRow.vala"
			g_object_set (_tmp10_, "icon-name", "user-away", NULL);
#line 227 "../src/DeviceRow.vala"
			_tmp11_ = self->priv->settings_button;
#line 227 "../src/DeviceRow.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp11_, FALSE);
#line 228 "../src/DeviceRow.vala"
			break;
#line 926 "DeviceRow.c"
		}
#line 217 "../src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_STATUS_CONNECTED:
#line 930 "DeviceRow.c"
		{
			GtkButton* _tmp12_;
			GtkButton* _tmp13_;
			GtkImage* _tmp14_;
			GtkLinkButton* _tmp15_;
			const gchar* _tmp16_;
			const gchar* _tmp17_;
#line 230 "../src/DeviceRow.vala"
			_tmp12_ = self->priv->connect_button;
#line 230 "../src/DeviceRow.vala"
			gtk_button_set_label (_tmp12_, _ ("Disconnect"));
#line 231 "../src/DeviceRow.vala"
			_tmp13_ = self->priv->connect_button;
#line 231 "../src/DeviceRow.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp13_, TRUE);
#line 232 "../src/DeviceRow.vala"
			_tmp14_ = self->priv->state;
#line 232 "../src/DeviceRow.vala"
			g_object_set (_tmp14_, "icon-name", "user-available", NULL);
#line 233 "../src/DeviceRow.vala"
			_tmp15_ = self->priv->settings_button;
#line 233 "../src/DeviceRow.vala"
			_tmp16_ = gtk_link_button_get_uri (_tmp15_);
#line 233 "../src/DeviceRow.vala"
			_tmp17_ = _tmp16_;
#line 233 "../src/DeviceRow.vala"
			if (g_strcmp0 (_tmp17_, "") != 0) {
#line 958 "DeviceRow.c"
				GtkLinkButton* _tmp18_;
#line 234 "../src/DeviceRow.vala"
				_tmp18_ = self->priv->settings_button;
#line 234 "../src/DeviceRow.vala"
				gtk_widget_set_visible ((GtkWidget*) _tmp18_, TRUE);
#line 964 "DeviceRow.c"
			}
#line 236 "../src/DeviceRow.vala"
			break;
#line 968 "DeviceRow.c"
		}
#line 217 "../src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_STATUS_CONNECTING:
#line 972 "DeviceRow.c"
		{
			GtkButton* _tmp19_;
			GtkImage* _tmp20_;
			GtkLinkButton* _tmp21_;
#line 238 "../src/DeviceRow.vala"
			_tmp19_ = self->priv->connect_button;
#line 238 "../src/DeviceRow.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp19_, FALSE);
#line 239 "../src/DeviceRow.vala"
			_tmp20_ = self->priv->state;
#line 239 "../src/DeviceRow.vala"
			g_object_set (_tmp20_, "icon-name", "user-away", NULL);
#line 240 "../src/DeviceRow.vala"
			_tmp21_ = self->priv->settings_button;
#line 240 "../src/DeviceRow.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp21_, FALSE);
#line 241 "../src/DeviceRow.vala"
			break;
#line 991 "DeviceRow.c"
		}
#line 217 "../src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_STATUS_DISCONNECTING:
#line 995 "DeviceRow.c"
		{
			GtkButton* _tmp22_;
			GtkImage* _tmp23_;
			GtkLinkButton* _tmp24_;
#line 243 "../src/DeviceRow.vala"
			_tmp22_ = self->priv->connect_button;
#line 243 "../src/DeviceRow.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp22_, FALSE);
#line 244 "../src/DeviceRow.vala"
			_tmp23_ = self->priv->state;
#line 244 "../src/DeviceRow.vala"
			g_object_set (_tmp23_, "icon-name", "user-away", NULL);
#line 245 "../src/DeviceRow.vala"
			_tmp24_ = self->priv->settings_button;
#line 245 "../src/DeviceRow.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp24_, FALSE);
#line 246 "../src/DeviceRow.vala"
			break;
#line 1014 "DeviceRow.c"
		}
#line 217 "../src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_STATUS_NOT_CONNECTED:
#line 1018 "DeviceRow.c"
		{
			GtkButton* _tmp25_;
			GtkButton* _tmp26_;
			GtkImage* _tmp27_;
			GtkLinkButton* _tmp28_;
#line 248 "../src/DeviceRow.vala"
			_tmp25_ = self->priv->connect_button;
#line 248 "../src/DeviceRow.vala"
			gtk_button_set_label (_tmp25_, _ ("Connect"));
#line 249 "../src/DeviceRow.vala"
			_tmp26_ = self->priv->connect_button;
#line 249 "../src/DeviceRow.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp26_, TRUE);
#line 250 "../src/DeviceRow.vala"
			_tmp27_ = self->priv->state;
#line 250 "../src/DeviceRow.vala"
			g_object_set (_tmp27_, "icon-name", "user-offline", NULL);
#line 251 "../src/DeviceRow.vala"
			_tmp28_ = self->priv->settings_button;
#line 251 "../src/DeviceRow.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp28_, FALSE);
#line 252 "../src/DeviceRow.vala"
			break;
#line 1042 "DeviceRow.c"
		}
#line 217 "../src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT:
#line 1046 "DeviceRow.c"
		{
			GtkButton* _tmp29_;
			GtkImage* _tmp30_;
			GtkLinkButton* _tmp31_;
#line 254 "../src/DeviceRow.vala"
			_tmp29_ = self->priv->connect_button;
#line 254 "../src/DeviceRow.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp29_, TRUE);
#line 255 "../src/DeviceRow.vala"
			_tmp30_ = self->priv->state;
#line 255 "../src/DeviceRow.vala"
			g_object_set (_tmp30_, "icon-name", "user-busy", NULL);
#line 256 "../src/DeviceRow.vala"
			_tmp31_ = self->priv->settings_button;
#line 256 "../src/DeviceRow.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp31_, FALSE);
#line 257 "../src/DeviceRow.vala"
			break;
#line 1065 "DeviceRow.c"
		}
		default:
#line 217 "../src/DeviceRow.vala"
		break;
#line 1070 "DeviceRow.c"
	}
}


BluetoothServicesDevice*
bluetooth_device_row_get_device (BluetoothDeviceRow* self)
{
	BluetoothServicesDevice* result;
	BluetoothServicesDevice* _tmp0_;
#line 22 "../src/DeviceRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 22 "../src/DeviceRow.vala"
	_tmp0_ = self->priv->_device;
#line 22 "../src/DeviceRow.vala"
	result = _tmp0_;
#line 22 "../src/DeviceRow.vala"
	return result;
#line 1088 "DeviceRow.c"
}


static void
bluetooth_device_row_set_device (BluetoothDeviceRow* self,
                                 BluetoothServicesDevice* value)
{
#line 22 "../src/DeviceRow.vala"
	g_return_if_fail (self != NULL);
#line 22 "../src/DeviceRow.vala"
	if (bluetooth_device_row_get_device (self) != value) {
#line 1100 "DeviceRow.c"
		BluetoothServicesDevice* _tmp0_;
#line 22 "../src/DeviceRow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 22 "../src/DeviceRow.vala"
		_g_object_unref0 (self->priv->_device);
#line 22 "../src/DeviceRow.vala"
		self->priv->_device = _tmp0_;
#line 22 "../src/DeviceRow.vala"
		g_object_notify_by_pspec ((GObject *) self, bluetooth_device_row_properties[BLUETOOTH_DEVICE_ROW_DEVICE_PROPERTY]);
#line 1110 "DeviceRow.c"
	}
}


BluetoothServicesAdapter*
bluetooth_device_row_get_adapter (BluetoothDeviceRow* self)
{
	BluetoothServicesAdapter* result;
	BluetoothServicesAdapter* _tmp0_;
#line 23 "../src/DeviceRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../src/DeviceRow.vala"
	_tmp0_ = self->priv->_adapter;
#line 23 "../src/DeviceRow.vala"
	result = _tmp0_;
#line 23 "../src/DeviceRow.vala"
	return result;
#line 1128 "DeviceRow.c"
}


static void
bluetooth_device_row_set_adapter (BluetoothDeviceRow* self,
                                  BluetoothServicesAdapter* value)
{
#line 23 "../src/DeviceRow.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/DeviceRow.vala"
	if (bluetooth_device_row_get_adapter (self) != value) {
#line 23 "../src/DeviceRow.vala"
		self->priv->_adapter = value;
#line 23 "../src/DeviceRow.vala"
		g_object_notify_by_pspec ((GObject *) self, bluetooth_device_row_properties[BLUETOOTH_DEVICE_ROW_ADAPTER_PROPERTY]);
#line 1144 "DeviceRow.c"
	}
}


static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 68 "../src/DeviceRow.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 68 "../src/DeviceRow.vala"
	return _data2_;
#line 1156 "DeviceRow.c"
}


static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 68 "../src/DeviceRow.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 1167 "DeviceRow.c"
		BluetoothDeviceRow* self;
#line 68 "../src/DeviceRow.vala"
		self = _data2_->self;
#line 68 "../src/DeviceRow.vala"
		_g_object_unref0 (_data2_->label);
#line 68 "../src/DeviceRow.vala"
		_g_object_unref0 (_data2_->image);
#line 68 "../src/DeviceRow.vala"
		_g_object_unref0 (self);
#line 68 "../src/DeviceRow.vala"
		g_slice_free (Block2Data, _data2_);
#line 1179 "DeviceRow.c"
	}
}


static void
_bluetooth_device_row___lambda8_ (BluetoothDeviceRow* self,
                                  GVariant* changed,
                                  gchar** invalid,
                                  int invalid_length1)
{
	GVariant* powered = NULL;
	GVariantType* _tmp0_;
	GVariantType* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
#line 138 "../src/DeviceRow.vala"
	g_return_if_fail (changed != NULL);
#line 139 "../src/DeviceRow.vala"
	_tmp0_ = g_variant_type_new ("b");
#line 139 "../src/DeviceRow.vala"
	_tmp1_ = _tmp0_;
#line 139 "../src/DeviceRow.vala"
	_tmp2_ = g_variant_lookup_value (changed, "Powered", _tmp1_);
#line 139 "../src/DeviceRow.vala"
	_tmp3_ = _tmp2_;
#line 139 "../src/DeviceRow.vala"
	_g_variant_type_free0 (_tmp1_);
#line 139 "../src/DeviceRow.vala"
	powered = _tmp3_;
#line 140 "../src/DeviceRow.vala"
	_tmp4_ = powered;
#line 140 "../src/DeviceRow.vala"
	if (_tmp4_ != NULL) {
#line 1214 "DeviceRow.c"
		BluetoothServicesAdapter* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 141 "../src/DeviceRow.vala"
		_tmp5_ = self->priv->_adapter;
#line 141 "../src/DeviceRow.vala"
		_tmp6_ = bluetooth_services_adapter_get_powered (_tmp5_);
#line 141 "../src/DeviceRow.vala"
		_tmp7_ = _tmp6_;
#line 141 "../src/DeviceRow.vala"
		gtk_widget_set_sensitive ((GtkWidget*) self, _tmp7_);
#line 142 "../src/DeviceRow.vala"
		gtk_list_box_row_changed ((GtkListBoxRow*) self);
#line 1228 "DeviceRow.c"
	}
#line 138 "../src/DeviceRow.vala"
	_g_variant_unref0 (powered);
#line 1232 "DeviceRow.c"
}


static void
__bluetooth_device_row___lambda8__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                                     GVariant* changed_properties,
                                                                     gchar** invalidated_properties,
                                                                     gpointer self)
{
#line 138 "../src/DeviceRow.vala"
	_bluetooth_device_row___lambda8_ ((BluetoothDeviceRow*) self, changed_properties, invalidated_properties, _vala_array_length (invalidated_properties));
#line 1244 "DeviceRow.c"
}


static void
_bluetooth_device_row___lambda9_ (Block2Data* _data2_,
                                  GVariant* changed,
                                  gchar** invalid,
                                  int invalid_length1)
{
	BluetoothDeviceRow* self;
	GVariant* paired = NULL;
	GVariantType* _tmp0_;
	GVariantType* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
	GVariant* connected = NULL;
	GVariantType* _tmp5_;
	GVariantType* _tmp6_;
	GVariant* _tmp7_;
	GVariant* _tmp8_;
	GVariant* _tmp9_;
	GVariant* name = NULL;
	GVariantType* _tmp10_;
	GVariantType* _tmp11_;
	GVariant* _tmp12_;
	GVariant* _tmp13_;
	GVariant* _tmp14_;
	GVariant* icon = NULL;
	GVariantType* _tmp20_;
	GVariantType* _tmp21_;
	GVariant* _tmp22_;
	GVariant* _tmp23_;
	GVariant* _tmp24_;
#line 146 "../src/DeviceRow.vala"
	self = _data2_->self;
#line 146 "../src/DeviceRow.vala"
	g_return_if_fail (changed != NULL);
#line 147 "../src/DeviceRow.vala"
	_tmp0_ = g_variant_type_new ("b");
#line 147 "../src/DeviceRow.vala"
	_tmp1_ = _tmp0_;
#line 147 "../src/DeviceRow.vala"
	_tmp2_ = g_variant_lookup_value (changed, "Paired", _tmp1_);
#line 147 "../src/DeviceRow.vala"
	_tmp3_ = _tmp2_;
#line 147 "../src/DeviceRow.vala"
	_g_variant_type_free0 (_tmp1_);
#line 147 "../src/DeviceRow.vala"
	paired = _tmp3_;
#line 148 "../src/DeviceRow.vala"
	_tmp4_ = paired;
#line 148 "../src/DeviceRow.vala"
	if (_tmp4_ != NULL) {
#line 149 "../src/DeviceRow.vala"
		bluetooth_device_row_compute_status (self);
#line 150 "../src/DeviceRow.vala"
		gtk_list_box_row_changed ((GtkListBoxRow*) self);
#line 1303 "DeviceRow.c"
	}
#line 153 "../src/DeviceRow.vala"
	_tmp5_ = g_variant_type_new ("b");
#line 153 "../src/DeviceRow.vala"
	_tmp6_ = _tmp5_;
#line 153 "../src/DeviceRow.vala"
	_tmp7_ = g_variant_lookup_value (changed, "Connected", _tmp6_);
#line 153 "../src/DeviceRow.vala"
	_tmp8_ = _tmp7_;
#line 153 "../src/DeviceRow.vala"
	_g_variant_type_free0 (_tmp6_);
#line 153 "../src/DeviceRow.vala"
	connected = _tmp8_;
#line 154 "../src/DeviceRow.vala"
	_tmp9_ = connected;
#line 154 "../src/DeviceRow.vala"
	if (_tmp9_ != NULL) {
#line 155 "../src/DeviceRow.vala"
		bluetooth_device_row_compute_status (self);
#line 156 "../src/DeviceRow.vala"
		gtk_list_box_row_changed ((GtkListBoxRow*) self);
#line 1325 "DeviceRow.c"
	}
#line 159 "../src/DeviceRow.vala"
	_tmp10_ = g_variant_type_new ("s");
#line 159 "../src/DeviceRow.vala"
	_tmp11_ = _tmp10_;
#line 159 "../src/DeviceRow.vala"
	_tmp12_ = g_variant_lookup_value (changed, "Name", _tmp11_);
#line 159 "../src/DeviceRow.vala"
	_tmp13_ = _tmp12_;
#line 159 "../src/DeviceRow.vala"
	_g_variant_type_free0 (_tmp11_);
#line 159 "../src/DeviceRow.vala"
	name = _tmp13_;
#line 160 "../src/DeviceRow.vala"
	_tmp14_ = name;
#line 160 "../src/DeviceRow.vala"
	if (_tmp14_ != NULL) {
#line 1343 "DeviceRow.c"
		GtkLabel* _tmp15_;
		BluetoothServicesDevice* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
#line 161 "../src/DeviceRow.vala"
		_tmp15_ = _data2_->label;
#line 161 "../src/DeviceRow.vala"
		_tmp16_ = self->priv->_device;
#line 161 "../src/DeviceRow.vala"
		_tmp17_ = bluetooth_services_device_get_name (_tmp16_);
#line 161 "../src/DeviceRow.vala"
		_tmp18_ = _tmp17_;
#line 161 "../src/DeviceRow.vala"
		_tmp19_ = _tmp18_;
#line 161 "../src/DeviceRow.vala"
		gtk_label_set_label (_tmp15_, _tmp19_);
#line 161 "../src/DeviceRow.vala"
		_g_free0 (_tmp19_);
#line 1363 "DeviceRow.c"
	}
#line 164 "../src/DeviceRow.vala"
	_tmp20_ = g_variant_type_new ("s");
#line 164 "../src/DeviceRow.vala"
	_tmp21_ = _tmp20_;
#line 164 "../src/DeviceRow.vala"
	_tmp22_ = g_variant_lookup_value (changed, "Icon", _tmp21_);
#line 164 "../src/DeviceRow.vala"
	_tmp23_ = _tmp22_;
#line 164 "../src/DeviceRow.vala"
	_g_variant_type_free0 (_tmp21_);
#line 164 "../src/DeviceRow.vala"
	icon = _tmp23_;
#line 165 "../src/DeviceRow.vala"
	_tmp24_ = icon;
#line 165 "../src/DeviceRow.vala"
	if (_tmp24_ != NULL) {
#line 1381 "DeviceRow.c"
		gchar* _tmp25_ = NULL;
		BluetoothServicesDevice* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		GtkImage* _tmp30_;
#line 166 "../src/DeviceRow.vala"
		_tmp26_ = self->priv->_device;
#line 166 "../src/DeviceRow.vala"
		_tmp27_ = bluetooth_services_device_get_icon (_tmp26_);
#line 166 "../src/DeviceRow.vala"
		_tmp28_ = _tmp27_;
#line 166 "../src/DeviceRow.vala"
		_tmp25_ = _tmp28_;
#line 166 "../src/DeviceRow.vala"
		if (_tmp25_ == NULL) {
#line 1397 "DeviceRow.c"
			gchar* _tmp29_;
#line 166 "../src/DeviceRow.vala"
			_tmp29_ = g_strdup ("bluetooth");
#line 166 "../src/DeviceRow.vala"
			_g_free0 (_tmp25_);
#line 166 "../src/DeviceRow.vala"
			_tmp25_ = _tmp29_;
#line 1405 "DeviceRow.c"
		}
#line 166 "../src/DeviceRow.vala"
		_tmp30_ = _data2_->image;
#line 166 "../src/DeviceRow.vala"
		g_object_set (_tmp30_, "icon-name", _tmp25_, NULL);
#line 165 "../src/DeviceRow.vala"
		_g_free0 (_tmp25_);
#line 1413 "DeviceRow.c"
	}
#line 146 "../src/DeviceRow.vala"
	_g_variant_unref0 (icon);
#line 146 "../src/DeviceRow.vala"
	_g_variant_unref0 (name);
#line 146 "../src/DeviceRow.vala"
	_g_variant_unref0 (connected);
#line 146 "../src/DeviceRow.vala"
	_g_variant_unref0 (paired);
#line 1423 "DeviceRow.c"
}


static void
__bluetooth_device_row___lambda9__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                                     GVariant* changed_properties,
                                                                     gchar** invalidated_properties,
                                                                     gpointer self)
{
#line 146 "../src/DeviceRow.vala"
	_bluetooth_device_row___lambda9_ (self, changed_properties, invalidated_properties, _vala_array_length (invalidated_properties));
#line 1435 "DeviceRow.c"
}


static void
_bluetooth_device_row___lambda10_ (BluetoothDeviceRow* self)
{
#line 171 "../src/DeviceRow.vala"
	bluetooth_device_row_button_clicked (self, NULL, NULL);
#line 1444 "DeviceRow.c"
}


static void
__bluetooth_device_row___lambda10__gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self)
{
#line 170 "../src/DeviceRow.vala"
	_bluetooth_device_row___lambda10_ ((BluetoothDeviceRow*) self);
#line 1454 "DeviceRow.c"
}


static GObject *
bluetooth_device_row_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	BluetoothDeviceRow * self;
	Block2Data* _data2_;
	gchar* _tmp0_ = NULL;
	BluetoothServicesDevice* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GtkImage* _tmp5_;
	GtkImage* _tmp6_;
	GtkImage* _tmp7_;
	GtkImage* _tmp8_;
	GtkLabel* _tmp9_;
	GtkLabel* _tmp10_;
	GtkLabel* _tmp11_;
	GtkOverlay* overlay = NULL;
	GtkOverlay* _tmp12_;
	GtkOverlay* _tmp13_;
	BluetoothServicesDevice* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	GtkOverlay* _tmp18_;
	GtkImage* _tmp19_;
	GtkOverlay* _tmp20_;
	GtkImage* _tmp21_;
	gchar* _tmp22_ = NULL;
	BluetoothServicesDevice* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	GtkLabel* _tmp29_;
	GtkLabel* _tmp30_;
	GtkLabel* _tmp31_;
	GtkLabel* _tmp32_;
	GtkLinkButton* _tmp33_;
	GtkLinkButton* _tmp34_;
	GtkLinkButton* _tmp35_;
	GtkImage* _tmp36_;
	GtkImage* _tmp37_;
	GtkLinkButton* _tmp38_;
	GtkLinkButton* _tmp39_;
	GtkLinkButton* _tmp40_;
	GtkLinkButton* _tmp41_;
	GtkLinkButton* _tmp42_;
	GtkButton* _tmp43_;
	GtkButton* _tmp44_;
	GtkSizeGroup* _tmp45_;
	GtkButton* _tmp46_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp47_;
	GtkGrid* _tmp48_;
	GtkGrid* _tmp49_;
	GtkGrid* _tmp50_;
	GtkGrid* _tmp51_;
	GtkOverlay* _tmp52_;
	GtkGrid* _tmp53_;
	GtkLabel* _tmp54_;
	GtkGrid* _tmp55_;
	GtkLabel* _tmp56_;
	GtkGrid* _tmp57_;
	GtkLinkButton* _tmp58_;
	GtkGrid* _tmp59_;
	GtkButton* _tmp60_;
	GtkGrid* _tmp61_;
	BluetoothServicesDevice* _tmp62_;
	gchar* _tmp63_;
	gchar* _tmp64_;
	gchar* _tmp65_;
	GQuark _tmp67_ = 0U;
#line 115 "../src/DeviceRow.vala"
	static GQuark _tmp66_label0 = 0;
#line 115 "../src/DeviceRow.vala"
	static GQuark _tmp66_label1 = 0;
#line 115 "../src/DeviceRow.vala"
	static GQuark _tmp66_label2 = 0;
#line 115 "../src/DeviceRow.vala"
	static GQuark _tmp66_label3 = 0;
#line 115 "../src/DeviceRow.vala"
	static GQuark _tmp66_label4 = 0;
#line 1542 "DeviceRow.c"
	BluetoothServicesAdapter* _tmp76_;
	gboolean _tmp77_;
	gboolean _tmp78_;
	BluetoothServicesAdapter* _tmp79_;
	BluetoothServicesDevice* _tmp80_;
	GtkButton* _tmp81_;
#line 68 "../src/DeviceRow.vala"
	parent_class = G_OBJECT_CLASS (bluetooth_device_row_parent_class);
#line 68 "../src/DeviceRow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 68 "../src/DeviceRow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BLUETOOTH_TYPE_DEVICE_ROW, BluetoothDeviceRow);
#line 68 "../src/DeviceRow.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 68 "../src/DeviceRow.vala"
	_data2_->_ref_count_ = 1;
#line 68 "../src/DeviceRow.vala"
	_data2_->self = g_object_ref (self);
#line 69 "../src/DeviceRow.vala"
	_tmp1_ = self->priv->_device;
#line 69 "../src/DeviceRow.vala"
	_tmp2_ = bluetooth_services_device_get_icon (_tmp1_);
#line 69 "../src/DeviceRow.vala"
	_tmp3_ = _tmp2_;
#line 69 "../src/DeviceRow.vala"
	_tmp0_ = _tmp3_;
#line 69 "../src/DeviceRow.vala"
	if (_tmp0_ == NULL) {
#line 1571 "DeviceRow.c"
		gchar* _tmp4_;
#line 69 "../src/DeviceRow.vala"
		_tmp4_ = g_strdup ("bluetooth");
#line 69 "../src/DeviceRow.vala"
		_g_free0 (_tmp0_);
#line 69 "../src/DeviceRow.vala"
		_tmp0_ = _tmp4_;
#line 1579 "DeviceRow.c"
	}
#line 69 "../src/DeviceRow.vala"
	_tmp5_ = (GtkImage*) gtk_image_new_from_icon_name (_tmp0_, (GtkIconSize) GTK_ICON_SIZE_DND);
#line 69 "../src/DeviceRow.vala"
	g_object_ref_sink (_tmp5_);
#line 69 "../src/DeviceRow.vala"
	_data2_->image = _tmp5_;
#line 71 "../src/DeviceRow.vala"
	_tmp6_ = (GtkImage*) gtk_image_new_from_icon_name ("user-offline", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 71 "../src/DeviceRow.vala"
	g_object_ref_sink (_tmp6_);
#line 71 "../src/DeviceRow.vala"
	_g_object_unref0 (self->priv->state);
#line 71 "../src/DeviceRow.vala"
	self->priv->state = _tmp6_;
#line 72 "../src/DeviceRow.vala"
	_tmp7_ = self->priv->state;
#line 72 "../src/DeviceRow.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp7_, GTK_ALIGN_END);
#line 73 "../src/DeviceRow.vala"
	_tmp8_ = self->priv->state;
#line 73 "../src/DeviceRow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp8_, GTK_ALIGN_END);
#line 75 "../src/DeviceRow.vala"
	_tmp9_ = (GtkLabel*) gtk_label_new (NULL);
#line 75 "../src/DeviceRow.vala"
	g_object_ref_sink (_tmp9_);
#line 75 "../src/DeviceRow.vala"
	_g_object_unref0 (self->priv->state_label);
#line 75 "../src/DeviceRow.vala"
	self->priv->state_label = _tmp9_;
#line 76 "../src/DeviceRow.vala"
	_tmp10_ = self->priv->state_label;
#line 76 "../src/DeviceRow.vala"
	gtk_label_set_xalign (_tmp10_, (gfloat) 0);
#line 77 "../src/DeviceRow.vala"
	_tmp11_ = self->priv->state_label;
#line 77 "../src/DeviceRow.vala"
	gtk_label_set_use_markup (_tmp11_, TRUE);
#line 79 "../src/DeviceRow.vala"
	_tmp12_ = (GtkOverlay*) gtk_overlay_new ();
#line 79 "../src/DeviceRow.vala"
	g_object_ref_sink (_tmp12_);
#line 79 "../src/DeviceRow.vala"
	overlay = _tmp12_;
#line 80 "../src/DeviceRow.vala"
	_tmp13_ = overlay;
#line 80 "../src/DeviceRow.vala"
	_tmp14_ = self->priv->_device;
#line 80 "../src/DeviceRow.vala"
	_tmp15_ = bluetooth_services_device_get_address (_tmp14_);
#line 80 "../src/DeviceRow.vala"
	_tmp16_ = _tmp15_;
#line 80 "../src/DeviceRow.vala"
	_tmp17_ = _tmp16_;
#line 80 "../src/DeviceRow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp13_, _tmp17_);
#line 80 "../src/DeviceRow.vala"
	_g_free0 (_tmp17_);
#line 81 "../src/DeviceRow.vala"
	_tmp18_ = overlay;
#line 81 "../src/DeviceRow.vala"
	_tmp19_ = _data2_->image;
#line 81 "../src/DeviceRow.vala"
	gtk_container_add ((GtkContainer*) _tmp18_, (GtkWidget*) _tmp19_);
#line 82 "../src/DeviceRow.vala"
	_tmp20_ = overlay;
#line 82 "../src/DeviceRow.vala"
	_tmp21_ = self->priv->state;
#line 82 "../src/DeviceRow.vala"
	gtk_overlay_add_overlay (_tmp20_, (GtkWidget*) _tmp21_);
#line 84 "../src/DeviceRow.vala"
	_tmp23_ = self->priv->_device;
#line 84 "../src/DeviceRow.vala"
	_tmp24_ = bluetooth_services_device_get_name (_tmp23_);
#line 84 "../src/DeviceRow.vala"
	_tmp25_ = _tmp24_;
#line 84 "../src/DeviceRow.vala"
	_tmp22_ = _tmp25_;
#line 84 "../src/DeviceRow.vala"
	if (_tmp22_ == NULL) {
#line 1661 "DeviceRow.c"
		BluetoothServicesDevice* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
#line 84 "../src/DeviceRow.vala"
		_tmp26_ = self->priv->_device;
#line 84 "../src/DeviceRow.vala"
		_tmp27_ = bluetooth_services_device_get_address (_tmp26_);
#line 84 "../src/DeviceRow.vala"
		_tmp28_ = _tmp27_;
#line 84 "../src/DeviceRow.vala"
		_g_free0 (_tmp22_);
#line 84 "../src/DeviceRow.vala"
		_tmp22_ = _tmp28_;
#line 1675 "DeviceRow.c"
	}
#line 84 "../src/DeviceRow.vala"
	_tmp29_ = (GtkLabel*) gtk_label_new (_tmp22_);
#line 84 "../src/DeviceRow.vala"
	g_object_ref_sink (_tmp29_);
#line 84 "../src/DeviceRow.vala"
	_data2_->label = _tmp29_;
#line 85 "../src/DeviceRow.vala"
	_tmp30_ = _data2_->label;
#line 85 "../src/DeviceRow.vala"
	gtk_label_set_ellipsize (_tmp30_, PANGO_ELLIPSIZE_END);
#line 86 "../src/DeviceRow.vala"
	_tmp31_ = _data2_->label;
#line 86 "../src/DeviceRow.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp31_, TRUE);
#line 87 "../src/DeviceRow.vala"
	_tmp32_ = _data2_->label;
#line 87 "../src/DeviceRow.vala"
	gtk_label_set_xalign (_tmp32_, (gfloat) 0);
#line 89 "../src/DeviceRow.vala"
	_tmp33_ = (GtkLinkButton*) gtk_link_button_new ("");
#line 89 "../src/DeviceRow.vala"
	g_object_ref_sink (_tmp33_);
#line 89 "../src/DeviceRow.vala"
	_g_object_unref0 (self->priv->settings_button);
#line 89 "../src/DeviceRow.vala"
	self->priv->settings_button = _tmp33_;
#line 90 "../src/DeviceRow.vala"
	_tmp34_ = self->priv->settings_button;
#line 90 "../src/DeviceRow.vala"
	gtk_button_set_always_show_image ((GtkButton*) _tmp34_, TRUE);
#line 91 "../src/DeviceRow.vala"
	_tmp35_ = self->priv->settings_button;
#line 91 "../src/DeviceRow.vala"
	_tmp36_ = (GtkImage*) gtk_image_new_from_icon_name ("view-more-horizontal-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 91 "../src/DeviceRow.vala"
	g_object_ref_sink (_tmp36_);
#line 91 "../src/DeviceRow.vala"
	_tmp37_ = _tmp36_;
#line 91 "../src/DeviceRow.vala"
	gtk_button_set_image ((GtkButton*) _tmp35_, (GtkWidget*) _tmp37_);
#line 91 "../src/DeviceRow.vala"
	_g_object_unref0 (_tmp37_);
#line 92 "../src/DeviceRow.vala"
	_tmp38_ = self->priv->settings_button;
#line 92 "../src/DeviceRow.vala"
	gtk_button_set_label ((GtkButton*) _tmp38_, NULL);
#line 93 "../src/DeviceRow.vala"
	_tmp39_ = self->priv->settings_button;
#line 93 "../src/DeviceRow.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp39_, 3);
#line 94 "../src/DeviceRow.vala"
	_tmp40_ = self->priv->settings_button;
#line 94 "../src/DeviceRow.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp40_);
#line 95 "../src/DeviceRow.vala"
	_tmp41_ = self->priv->settings_button;
#line 95 "../src/DeviceRow.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp41_, TRUE);
#line 96 "../src/DeviceRow.vala"
	_tmp42_ = self->priv->settings_button;
#line 96 "../src/DeviceRow.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp42_, FALSE);
#line 98 "../src/DeviceRow.vala"
	_tmp43_ = (GtkButton*) gtk_button_new ();
#line 98 "../src/DeviceRow.vala"
	g_object_ref_sink (_tmp43_);
#line 98 "../src/DeviceRow.vala"
	_g_object_unref0 (self->priv->connect_button);
#line 98 "../src/DeviceRow.vala"
	self->priv->connect_button = _tmp43_;
#line 99 "../src/DeviceRow.vala"
	_tmp44_ = self->priv->connect_button;
#line 99 "../src/DeviceRow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp44_, GTK_ALIGN_CENTER);
#line 100 "../src/DeviceRow.vala"
	_tmp45_ = bluetooth_device_row_size_group;
#line 100 "../src/DeviceRow.vala"
	_tmp46_ = self->priv->connect_button;
#line 100 "../src/DeviceRow.vala"
	gtk_size_group_add_widget (_tmp45_, (GtkWidget*) _tmp46_);
#line 102 "../src/DeviceRow.vala"
	_tmp47_ = (GtkGrid*) gtk_grid_new ();
#line 102 "../src/DeviceRow.vala"
	g_object_ref_sink (_tmp47_);
#line 102 "../src/DeviceRow.vala"
	grid = _tmp47_;
#line 103 "../src/DeviceRow.vala"
	_tmp48_ = grid;
#line 103 "../src/DeviceRow.vala"
	g_object_set ((GtkWidget*) _tmp48_, "margin", 6, NULL);
#line 104 "../src/DeviceRow.vala"
	_tmp49_ = grid;
#line 104 "../src/DeviceRow.vala"
	gtk_grid_set_column_spacing (_tmp49_, 6);
#line 105 "../src/DeviceRow.vala"
	_tmp50_ = grid;
#line 105 "../src/DeviceRow.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp50_, GTK_ORIENTATION_HORIZONTAL);
#line 106 "../src/DeviceRow.vala"
	_tmp51_ = grid;
#line 106 "../src/DeviceRow.vala"
	_tmp52_ = overlay;
#line 106 "../src/DeviceRow.vala"
	gtk_grid_attach (_tmp51_, (GtkWidget*) _tmp52_, 0, 0, 1, 2);
#line 107 "../src/DeviceRow.vala"
	_tmp53_ = grid;
#line 107 "../src/DeviceRow.vala"
	_tmp54_ = _data2_->label;
#line 107 "../src/DeviceRow.vala"
	gtk_grid_attach (_tmp53_, (GtkWidget*) _tmp54_, 1, 0, 1, 1);
#line 108 "../src/DeviceRow.vala"
	_tmp55_ = grid;
#line 108 "../src/DeviceRow.vala"
	_tmp56_ = self->priv->state_label;
#line 108 "../src/DeviceRow.vala"
	gtk_grid_attach (_tmp55_, (GtkWidget*) _tmp56_, 1, 1, 1, 1);
#line 109 "../src/DeviceRow.vala"
	_tmp57_ = grid;
#line 109 "../src/DeviceRow.vala"
	_tmp58_ = self->priv->settings_button;
#line 109 "../src/DeviceRow.vala"
	gtk_grid_attach (_tmp57_, (GtkWidget*) _tmp58_, 2, 0, 1, 2);
#line 110 "../src/DeviceRow.vala"
	_tmp59_ = grid;
#line 110 "../src/DeviceRow.vala"
	_tmp60_ = self->priv->connect_button;
#line 110 "../src/DeviceRow.vala"
	gtk_grid_attach (_tmp59_, (GtkWidget*) _tmp60_, 3, 0, 1, 2);
#line 112 "../src/DeviceRow.vala"
	_tmp61_ = grid;
#line 112 "../src/DeviceRow.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp61_);
#line 113 "../src/DeviceRow.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 115 "../src/DeviceRow.vala"
	_tmp62_ = self->priv->_device;
#line 115 "../src/DeviceRow.vala"
	_tmp63_ = bluetooth_services_device_get_icon (_tmp62_);
#line 115 "../src/DeviceRow.vala"
	_tmp64_ = _tmp63_;
#line 115 "../src/DeviceRow.vala"
	_tmp65_ = _tmp64_;
#line 115 "../src/DeviceRow.vala"
	_tmp67_ = (NULL == _tmp65_) ? 0 : g_quark_from_string (_tmp65_);
#line 115 "../src/DeviceRow.vala"
	g_free (_tmp65_);
#line 115 "../src/DeviceRow.vala"
	if (_tmp67_ == ((0 != _tmp66_label0) ? _tmp66_label0 : (_tmp66_label0 = g_quark_from_static_string ("audio-card")))) {
#line 115 "../src/DeviceRow.vala"
		switch (0) {
#line 1827 "DeviceRow.c"
			default:
			{
				GtkLinkButton* _tmp68_;
				GtkLinkButton* _tmp69_;
#line 117 "../src/DeviceRow.vala"
				_tmp68_ = self->priv->settings_button;
#line 117 "../src/DeviceRow.vala"
				gtk_link_button_set_uri (_tmp68_, "settings://sound");
#line 118 "../src/DeviceRow.vala"
				_tmp69_ = self->priv->settings_button;
#line 118 "../src/DeviceRow.vala"
				gtk_widget_set_tooltip_text ((GtkWidget*) _tmp69_, _ ("Sound Settings"));
#line 119 "../src/DeviceRow.vala"
				break;
#line 1842 "DeviceRow.c"
			}
		}
	} else if ((_tmp67_ == ((0 != _tmp66_label1) ? _tmp66_label1 : (_tmp66_label1 = g_quark_from_static_string ("input-gaming")))) || (_tmp67_ == ((0 != _tmp66_label2) ? _tmp66_label2 : (_tmp66_label2 = g_quark_from_static_string ("input-keyboard"))))) {
#line 115 "../src/DeviceRow.vala"
		switch (0) {
#line 1848 "DeviceRow.c"
			default:
			{
				GtkLinkButton* _tmp70_;
				GtkLinkButton* _tmp71_;
#line 122 "../src/DeviceRow.vala"
				_tmp70_ = self->priv->settings_button;
#line 122 "../src/DeviceRow.vala"
				gtk_link_button_set_uri (_tmp70_, "settings://input/keyboard");
#line 123 "../src/DeviceRow.vala"
				_tmp71_ = self->priv->settings_button;
#line 123 "../src/DeviceRow.vala"
				gtk_widget_set_tooltip_text ((GtkWidget*) _tmp71_, _ ("Keyboard Settings"));
#line 124 "../src/DeviceRow.vala"
				break;
#line 1863 "DeviceRow.c"
			}
		}
	} else if (_tmp67_ == ((0 != _tmp66_label3) ? _tmp66_label3 : (_tmp66_label3 = g_quark_from_static_string ("input-mouse")))) {
#line 115 "../src/DeviceRow.vala"
		switch (0) {
#line 1869 "DeviceRow.c"
			default:
			{
				GtkLinkButton* _tmp72_;
				GtkLinkButton* _tmp73_;
#line 126 "../src/DeviceRow.vala"
				_tmp72_ = self->priv->settings_button;
#line 126 "../src/DeviceRow.vala"
				gtk_link_button_set_uri (_tmp72_, "settings://input/mouse");
#line 127 "../src/DeviceRow.vala"
				_tmp73_ = self->priv->settings_button;
#line 127 "../src/DeviceRow.vala"
				gtk_widget_set_tooltip_text ((GtkWidget*) _tmp73_, _ ("Mouse & Touchpad Settings"));
#line 128 "../src/DeviceRow.vala"
				break;
#line 1884 "DeviceRow.c"
			}
		}
	} else if (_tmp67_ == ((0 != _tmp66_label4) ? _tmp66_label4 : (_tmp66_label4 = g_quark_from_static_string ("printer")))) {
#line 115 "../src/DeviceRow.vala"
		switch (0) {
#line 1890 "DeviceRow.c"
			default:
			{
				GtkLinkButton* _tmp74_;
				GtkLinkButton* _tmp75_;
#line 130 "../src/DeviceRow.vala"
				_tmp74_ = self->priv->settings_button;
#line 130 "../src/DeviceRow.vala"
				gtk_link_button_set_uri (_tmp74_, "settings://printer");
#line 131 "../src/DeviceRow.vala"
				_tmp75_ = self->priv->settings_button;
#line 131 "../src/DeviceRow.vala"
				gtk_widget_set_tooltip_text ((GtkWidget*) _tmp75_, _ ("Printer Settings"));
#line 132 "../src/DeviceRow.vala"
				break;
#line 1905 "DeviceRow.c"
			}
		}
	}
#line 135 "../src/DeviceRow.vala"
	bluetooth_device_row_compute_status (self);
#line 136 "../src/DeviceRow.vala"
	_tmp76_ = self->priv->_adapter;
#line 136 "../src/DeviceRow.vala"
	_tmp77_ = bluetooth_services_adapter_get_powered (_tmp76_);
#line 136 "../src/DeviceRow.vala"
	_tmp78_ = _tmp77_;
#line 136 "../src/DeviceRow.vala"
	gtk_widget_set_sensitive ((GtkWidget*) self, _tmp78_);
#line 138 "../src/DeviceRow.vala"
	_tmp79_ = self->priv->_adapter;
#line 138 "../src/DeviceRow.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_TYPE (_tmp79_, g_dbus_proxy_get_type ()) ? ((GDBusProxy*) _tmp79_) : NULL, "g-properties-changed", (GCallback) __bluetooth_device_row___lambda8__g_dbus_proxy_g_properties_changed, self, 0);
#line 146 "../src/DeviceRow.vala"
	_tmp80_ = self->priv->_device;
#line 146 "../src/DeviceRow.vala"
	g_signal_connect_data (G_TYPE_CHECK_INSTANCE_TYPE (_tmp80_, g_dbus_proxy_get_type ()) ? ((GDBusProxy*) _tmp80_) : NULL, "g-properties-changed", (GCallback) __bluetooth_device_row___lambda9__g_dbus_proxy_g_properties_changed, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 170 "../src/DeviceRow.vala"
	_tmp81_ = self->priv->connect_button;
#line 170 "../src/DeviceRow.vala"
	g_signal_connect_object (_tmp81_, "clicked", (GCallback) __bluetooth_device_row___lambda10__gtk_button_clicked, self, 0);
#line 68 "../src/DeviceRow.vala"
	_g_object_unref0 (grid);
#line 68 "../src/DeviceRow.vala"
	_g_free0 (_tmp22_);
#line 68 "../src/DeviceRow.vala"
	_g_object_unref0 (overlay);
#line 68 "../src/DeviceRow.vala"
	_g_free0 (_tmp0_);
#line 68 "../src/DeviceRow.vala"
	block2_data_unref (_data2_);
#line 68 "../src/DeviceRow.vala"
	_data2_ = NULL;
#line 68 "../src/DeviceRow.vala"
	return obj;
#line 1945 "DeviceRow.c"
}


static void
bluetooth_device_row_class_init (BluetoothDeviceRowClass * klass)
{
	GtkSizeGroup* _tmp0_;
#line 21 "../src/DeviceRow.vala"
	bluetooth_device_row_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/DeviceRow.vala"
	g_type_class_adjust_private_offset (klass, &BluetoothDeviceRow_private_offset);
#line 21 "../src/DeviceRow.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_bluetooth_device_row_get_property;
#line 21 "../src/DeviceRow.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_bluetooth_device_row_set_property;
#line 21 "../src/DeviceRow.vala"
	G_OBJECT_CLASS (klass)->constructor = bluetooth_device_row_constructor;
#line 21 "../src/DeviceRow.vala"
	G_OBJECT_CLASS (klass)->finalize = bluetooth_device_row_finalize;
#line 21 "../src/DeviceRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BLUETOOTH_DEVICE_ROW_DEVICE_PROPERTY, bluetooth_device_row_properties[BLUETOOTH_DEVICE_ROW_DEVICE_PROPERTY] = g_param_spec_object ("device", "device", "device", BLUETOOTH_SERVICES_TYPE_DEVICE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 21 "../src/DeviceRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BLUETOOTH_DEVICE_ROW_ADAPTER_PROPERTY, bluetooth_device_row_properties[BLUETOOTH_DEVICE_ROW_ADAPTER_PROPERTY] = g_param_spec_object ("adapter", "adapter", "adapter", BLUETOOTH_SERVICES_TYPE_ADAPTER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 65 "../src/DeviceRow.vala"
	_tmp0_ = gtk_size_group_new (GTK_SIZE_GROUP_HORIZONTAL);
#line 65 "../src/DeviceRow.vala"
	_g_object_unref0 (bluetooth_device_row_size_group);
#line 65 "../src/DeviceRow.vala"
	bluetooth_device_row_size_group = _tmp0_;
#line 1975 "DeviceRow.c"
}


static void
bluetooth_device_row_instance_init (BluetoothDeviceRow * self)
{
#line 21 "../src/DeviceRow.vala"
	self->priv = bluetooth_device_row_get_instance_private (self);
#line 1984 "DeviceRow.c"
}


static void
bluetooth_device_row_finalize (GObject * obj)
{
	BluetoothDeviceRow * self;
#line 21 "../src/DeviceRow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BLUETOOTH_TYPE_DEVICE_ROW, BluetoothDeviceRow);
#line 22 "../src/DeviceRow.vala"
	_g_object_unref0 (self->priv->_device);
#line 55 "../src/DeviceRow.vala"
	_g_object_unref0 (self->priv->connect_button);
#line 56 "../src/DeviceRow.vala"
	_g_object_unref0 (self->priv->state);
#line 57 "../src/DeviceRow.vala"
	_g_object_unref0 (self->priv->state_label);
#line 58 "../src/DeviceRow.vala"
	_g_object_unref0 (self->priv->settings_button);
#line 21 "../src/DeviceRow.vala"
	G_OBJECT_CLASS (bluetooth_device_row_parent_class)->finalize (obj);
#line 2006 "DeviceRow.c"
}


GType
bluetooth_device_row_get_type (void)
{
	static volatile gsize bluetooth_device_row_type_id__volatile = 0;
	if (g_once_init_enter (&bluetooth_device_row_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BluetoothDeviceRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bluetooth_device_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BluetoothDeviceRow), 0, (GInstanceInitFunc) bluetooth_device_row_instance_init, NULL };
		GType bluetooth_device_row_type_id;
		bluetooth_device_row_type_id = g_type_register_static (gtk_list_box_row_get_type (), "BluetoothDeviceRow", &g_define_type_info, 0);
		BluetoothDeviceRow_private_offset = g_type_add_instance_private (bluetooth_device_row_type_id, sizeof (BluetoothDeviceRowPrivate));
		g_once_init_leave (&bluetooth_device_row_type_id__volatile, bluetooth_device_row_type_id);
	}
	return bluetooth_device_row_type_id__volatile;
}


static void
_vala_bluetooth_device_row_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	BluetoothDeviceRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BLUETOOTH_TYPE_DEVICE_ROW, BluetoothDeviceRow);
#line 21 "../src/DeviceRow.vala"
	switch (property_id) {
#line 21 "../src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_DEVICE_PROPERTY:
#line 21 "../src/DeviceRow.vala"
		g_value_set_object (value, bluetooth_device_row_get_device (self));
#line 21 "../src/DeviceRow.vala"
		break;
#line 21 "../src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_ADAPTER_PROPERTY:
#line 21 "../src/DeviceRow.vala"
		g_value_set_object (value, bluetooth_device_row_get_adapter (self));
#line 21 "../src/DeviceRow.vala"
		break;
#line 2047 "DeviceRow.c"
		default:
#line 21 "../src/DeviceRow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/DeviceRow.vala"
		break;
#line 2053 "DeviceRow.c"
	}
}


static void
_vala_bluetooth_device_row_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	BluetoothDeviceRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BLUETOOTH_TYPE_DEVICE_ROW, BluetoothDeviceRow);
#line 21 "../src/DeviceRow.vala"
	switch (property_id) {
#line 21 "../src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_DEVICE_PROPERTY:
#line 21 "../src/DeviceRow.vala"
		bluetooth_device_row_set_device (self, g_value_get_object (value));
#line 21 "../src/DeviceRow.vala"
		break;
#line 21 "../src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_ADAPTER_PROPERTY:
#line 21 "../src/DeviceRow.vala"
		bluetooth_device_row_set_adapter (self, g_value_get_object (value));
#line 21 "../src/DeviceRow.vala"
		break;
#line 2080 "DeviceRow.c"
		default:
#line 21 "../src/DeviceRow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/DeviceRow.vala"
		break;
#line 2086 "DeviceRow.c"
	}
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



